/*
 *
 * This software is subject to the terms of the IBM Public License.
 * You must accept the terms of this license to use this software.
 *
 *  Copyright (C) 2000, International Business Machines Corporation
 * and others.  All Rights Reserved.
 *
 *  Version : 1.0 (2000-07-19)
 *
 *  Author  :   Tadayuki Yoshida <tadayuki@jp.ibm.com>
 *
 */
#include <iconv.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <locale.h>
#include <limits.h>
#include <ctype.h>
/* #include <math.h> */

#define MIN_NUM_OF_PARAM_FOR_COMMAND     5
#define NUM_OF_KEYWORD                  9
#define MBCHAR_MAX                      8
#define MAX_NUMBER_OF_RANGE             16

#define UCSDATA 1
#define OTHERS  0

extern int getparams_iconv (int, char **, params *);
extern void print_help_iconv (void);
extern char * get_oneline_iconv_ucs ( FILE *, char **, int * );
extern char * get_oneline_iconv_mbs ( FILE *, char **, int * );

#if __BYTE_ORDER == __BIG_ENDIAN
#define SOL {0x00, 0x3c, 0x00, 0x53, 0x00, 0x4f, 0x00, 0x4c, 0x00, 0x3e}
#define EOL {0x00, 0x3c, 0x00, 0x45, 0x00, 0x4f, 0x00, 0x4c, 0x00, 0x3e}
#define RET {0x00, 0x0a}
#else
#define SOL {0x00, 0x3c, 0x00, 0x53, 0x00, 0x4f, 0x00, 0x4c, 0x00, 0x3e}
#define EOL {0x00, 0x3c, 0x00, 0x45, 0x00, 0x4f, 0x00, 0x4c, 0x00, 0x3e}
#define RET {0x00, 0x0a}
// #define SOL {0x3c, 0x00, 0x53, 0x00, 0x4f, 0x00, 0x4c, 0x00, 0x3e, 0x00}
// #define EOL {0x3c, 0x00, 0x45, 0x00, 0x4f, 0x00, 0x4c, 0x00, 0x3e, 0x00}
// #define RET {0x0a, 0x00}
#endif
